diff --git a/freebsd/sys/kern/kern_event.c b/freebsd/sys/kern/kern_event.c
index d9ec03c8..1c79ace8 100644
--- a/freebsd/sys/kern/kern_event.c
+++ b/freebsd/sys/kern/kern_event.c
@@ -81,8 +81,6 @@ __FBSDID("$FreeBSD$");
 
 #include <vm/uma.h>
 #ifdef __rtems__
-#include <machine/rtems-bsd-syscall-api.h>
-
 /* Maintain a global kqueue list on RTEMS */
 static struct kqlist fd_kqlist;
 #endif /* __rtems__ */
@@ -131,7 +129,6 @@ static int	kern_kevent_generic(struct thread *td,
 		    struct g_kevent_args *uap,
 		    struct kevent_copyops *k_ops, const char *struct_name);
 
-#ifndef __rtems__
 static fo_rdwr_t	kqueue_read;
 static fo_rdwr_t	kqueue_write;
 static fo_truncate_t	kqueue_truncate;
@@ -156,9 +153,6 @@ static struct fileops kqueueops = {
 	.fo_sendfile = invfo_sendfile,
 	.fo_fill_kinfo = kqueue_fill_kinfo,
 };
-#else /* __rtems__ */
-static const rtems_filesystem_file_handlers_r kqueueops;
-#endif /* __rtems__ */
 
 static int 	knote_attach(struct knote *kn, struct kqueue *kq);
 static void 	knote_drop(struct knote *kn, struct thread *td);
@@ -399,14 +393,27 @@ static int
 filt_fileattach(struct knote *kn)
 {
 
+#ifndef __rtems__
 	return (fo_kqfilter(kn->kn_fp, kn));
+#else /* __rtems__ */
+	if ((kn->kn_status & KN_FP_IS_IOP) == 0) {
+		return (fo_kqfilter(kn->kn_fp, kn));
+	} else {
+		rtems_libio_t* iop = (rtems_libio_t*) kn->kn_fp;
+		return ((*iop->pathinfo.handlers->kqfilter_h)(iop, kn));
+	}
+#endif /* __rtems__ */
 }
 
 /*ARGSUSED*/
 static int
 kqueue_kqfilter(struct file *fp, struct knote *kn)
 {
+#ifndef __rtems__
 	struct kqueue *kq = kn->kn_fp->f_data;
+#else /* __rtems__ */
+	struct kqueue *kq = rtems_bsd_libio_knote_to_kq(kn);
+#endif /* __rtems__ */
 
 	if (kn->kn_filter != EVFILT_READ)
 		return (EINVAL);
@@ -417,20 +424,15 @@ kqueue_kqfilter(struct file *fp, struct knote *kn)
 
 	return (0);
 }
-#ifdef __rtems__
-static int
-rtems_bsd_kqueue_kqfilter(rtems_libio_t *iop, struct knote *kn)
-{
-	struct file *fp = rtems_bsd_iop_to_fp(iop);
-
-	return kqueue_kqfilter(fp, kn);
-}
-#endif /* __rtems__ */
 
 static void
 filt_kqdetach(struct knote *kn)
 {
+#ifndef __rtems__
 	struct kqueue *kq = kn->kn_fp->f_data;
+#else /* __rtems__ */
+	struct kqueue *kq = rtems_bsd_libio_knote_to_kq(kn);
+#endif /* __rtems__ */
 
 	knlist_remove(&kq->kq_sel.si_note, kn, 0);
 }
@@ -439,7 +441,11 @@ filt_kqdetach(struct knote *kn)
 static int
 filt_kqueue(struct knote *kn, long hint)
 {
+#ifndef __rtems__
 	struct kqueue *kq = kn->kn_fp->f_data;
+#else /* __rtems__ */
+	struct kqueue *kq = rtems_bsd_libio_knote_to_kq(kn);
+#endif /* __rtems__ */
 
 	kn->kn_data = kq->kq_count;
 	return (kn->kn_data > 0);
@@ -991,12 +997,6 @@ filt_usertouch(struct knote *kn, struct kevent *kev, u_long type)
 	}
 }
 
-#ifdef __rtems__
-static int
-kern_kqueue(struct thread *td, int flags, struct filecaps *fcaps);
-
-static
-#endif /* __rtems__ */
 int
 sys_kqueue(struct thread *td, struct kqueue_args *uap)
 {
@@ -1023,15 +1023,10 @@ kern_kqueue(struct thread *td, int flags, struct filecaps *fcaps)
 	struct ucred *cred;
 	int fd, error;
 
-#ifndef __rtems__
 	fdp = td->td_proc->p_fd;
 	cred = td->td_ucred;
 	if (!chgkqcnt(cred->cr_ruidinfo, 1, lim_cur(td, RLIMIT_KQUEUES)))
 		return (ENOMEM);
-#else /* __rtems__ */
-	(void)fdp;
-	(void)cred;
-#endif /* __rtems__ */
 
 	error = falloc_caps(td, &fp, &fd, flags, fcaps);
 	if (error != 0) {
@@ -1042,50 +1037,19 @@ kern_kqueue(struct thread *td, int flags, struct filecaps *fcaps)
 	/* An extra reference on `fp' has been held for us by falloc(). */
 	kq = malloc(sizeof *kq, M_KQUEUE, M_WAITOK | M_ZERO);
 	kqueue_init(kq);
-#ifndef __rtems__
 	kq->kq_fdp = fdp;
 	kq->kq_cred = crhold(cred);
-#endif /* __rtems__ */
 
-#ifndef __rtems__
 	FILEDESC_XLOCK(fdp);
 	TAILQ_INSERT_HEAD(&fdp->fd_kqlist, kq, kq_list);
 	FILEDESC_XUNLOCK(fdp);
-#else /* __rtems__ */
-	rtems_libio_lock();
-	TAILQ_INSERT_HEAD(&fd_kqlist, kq, kq_list);
-	rtems_libio_unlock();
-#endif /* __rtems__ */
 
 	finit(fp, FREAD | FWRITE, DTYPE_KQUEUE, kq, &kqueueops);
-#ifndef __rtems__
 	fdrop(fp, td);
-#endif /* __rtems__ */
 
 	td->td_retval[0] = fd;
 	return (0);
 }
-#ifdef __rtems__
-int
-kqueue(void)
-{
-	struct thread *td = rtems_bsd_get_curthread_or_null();
-	struct kqueue_args ua;
-	int error;
-
-	if (td != NULL) {
-		error = sys_kqueue(td, &ua);
-	} else {
-		error = ENOMEM;
-	}
-
-	if (error == 0) {
-		return td->td_retval[0];
-	} else {
-		rtems_set_errno_and_return_minus_one(error);
-	}
-}
-#endif /* __rtems__ */
 
 struct g_kevent_args {
 	int	fd;
@@ -1096,15 +1060,6 @@ struct g_kevent_args {
 	const struct timespec *timeout;
 };
 
-#ifdef __rtems__
-static int kern_kevent(struct thread *td, int fd, int nchanges, int nevents,
-    struct kevent_copyops *k_ops, const struct timespec *timeout);
-
-static int kern_kevent_fp(struct thread *td, struct file *fp, int nchanges,
-    int nevents, struct kevent_copyops *k_ops, const struct timespec *timeout);
-
-static
-#endif /* __rtems__ */
 int
 sys_kevent(struct thread *td, struct kevent_args *uap)
 {
@@ -1161,38 +1116,6 @@ kern_kevent_generic(struct thread *td, struct g_kevent_args *uap,
 
 	return (error);
 }
-#ifdef __rtems__
-__weak_reference(kevent, _kevent);
-
-int
-kevent(int kq, const struct kevent *changelist, int nchanges,
-    struct kevent *eventlist, int nevents,
-    const struct timespec *timeout)
-{
-	struct thread *td = rtems_bsd_get_curthread_or_null();
-	struct kevent_args ua = {
-		.fd = kq,
-		.changelist = changelist,
-		.nchanges = nchanges,
-		.eventlist = eventlist,
-		.nevents = nevents,
-		.timeout = timeout
-	};
-	int error;
-
-	if (td != NULL) {
-		error = sys_kevent(td, &ua);
-	} else {
-		error = ENOMEM;
-	}
-
-	if (error == 0) {
-		return td->td_retval[0];
-	} else {
-		rtems_set_errno_and_return_minus_one(error);
-	}
-}
-#endif /* __rtems__ */
 
 /*
  * Copy 'count' items into the destination list pointed to by uap->eventlist.
@@ -1503,6 +1426,9 @@ kqueue_register(struct kqueue *kq, struct kevent *kev, struct thread *td,
 {
 	struct filterops *fops;
 	struct file *fp;
+#ifdef __rtems__
+	rtems_libio_t* iop = NULL;
+#endif /* __rtems__ */
 	struct knote *kn, *tkn;
 	struct knlist *knl;
 	int error, filt, event;
@@ -1540,15 +1466,39 @@ findkn:
 		if (kev->ident > INT_MAX)
 			error = EBADF;
 		else
+#ifndef __rtems__
 			error = fget(td, kev->ident, &cap_event_rights, &fp);
+#else /* __rtems__ */
+		{
+			int ffd = rtems_bsd_libio_iop_hold(kev->ident, &iop);
+			if (ffd < 0)
+				error = EBADF;
+			else {
+				if (iop == NULL)
+					error = fget(td, ffd, &cap_event_rights, &fp);
+				else
+					fp = NULL;
+			}
+		}
+#endif /* __rtems__ */
 		if (error)
 			goto done;
 
 		if ((kev->flags & EV_ADD) == EV_ADD && kqueue_expand(kq, fops,
 		    kev->ident, M_NOWAIT) != 0) {
+#ifndef __rtems__
 			/* try again */
 			fdrop(fp, td);
 			fp = NULL;
+#else /* __rtems__ */
+			if (fp != NULL) {
+				fdrop(fp, td);
+				fp = NULL;
+			} else if (iop != NULL) {
+				rtems_libio_iop_drop(iop);
+				iop = NULL;
+			}
+#endif /* __rtems__ */
 			error = kqueue_expand(kq, fops, kev->ident, mflag);
 			if (error)
 				goto done;
@@ -1558,7 +1508,7 @@ findkn:
 #ifndef __rtems__
 		if (fp->f_type == DTYPE_KQUEUE) {
 #else /* __rtems__ */
-		if (fp->f_io.pathinfo.handlers == &kqueueops) {
+		if (fp != NULL && fp->f_type == DTYPE_KQUEUE) {
 #endif /* __rtems__ */
 			/*
 			 * If we add some intelligence about what we are doing,
@@ -1632,6 +1582,12 @@ findkn:
 			fdrop(fp, td);
 			fp = NULL;
 		}
+#ifdef __rtems__
+		if (iop != NULL) {
+			rtems_libio_iop_drop(iop);
+			iop = NULL;
+		}
+#endif /* __rtems__ */
 		goto findkn;
 	}
 
@@ -1647,7 +1603,17 @@ findkn:
 				error = ENOMEM;
 				goto done;
 			}
+#ifndef __rtems__
 			kn->kn_fp = fp;
+#else /* __rtems__ */
+			if (fp != NULL) {
+				kn->kn_fp = fp;
+				kn->kn_status = 0;
+			} else if (iop != NULL) {
+				rtems_bsd_libio_iop_to_knote(kn, iop);
+				kn->kn_status = KN_FP_IS_IOP;
+			}
+#endif /* __rtems__ */
 			kn->kn_kq = kq;
 			kn->kn_fop = fops;
 			/*
@@ -1656,6 +1622,9 @@ findkn:
 			 */
 			fops = NULL;
 			fp = NULL;
+#ifdef __rtems__
+			iop = NULL;
+#endif /* __rtems__ */
 
 			kn->kn_sfflags = kev->fflags;
 			kn->kn_sdata = kev->data;
@@ -1664,7 +1633,11 @@ findkn:
 			kn->kn_kevent = *kev;
 			kn->kn_kevent.flags &= ~(EV_ADD | EV_DELETE |
 			    EV_ENABLE | EV_DISABLE | EV_FORCEONESHOT);
+#ifndef __rtems__
 			kn->kn_status = KN_DETACHED;
+#else /* __rtems__ */
+			kn->kn_status |= KN_DETACHED;
+#endif /* __rtems__ */
 			if ((kev->flags & EV_DISABLE) != 0)
 				kn->kn_status |= KN_DISABLED;
 			kn_enter_flux(kn);
@@ -1757,6 +1730,10 @@ done:
 		FILEDESC_XUNLOCK(td->td_proc->p_fd);
 	if (fp != NULL)
 		fdrop(fp, td);
+#ifdef __rtems__
+	if (iop != NULL)
+		rtems_libio_iop_drop(iop);
+#endif /* __rtems__ */
 	knote_free(tkn);
 	if (fops != NULL)
 		kqueue_fo_release(filt);
@@ -1772,11 +1749,7 @@ kqueue_acquire(struct file *fp, struct kqueue **kqp)
 	error = 0;
 
 	kq = fp->f_data;
-#ifndef __rtems__
 	if (fp->f_type != DTYPE_KQUEUE || kq == NULL)
-#else /* __rtems__ */
-	if (fp->f_io.pathinfo.handlers != &kqueueops || kq == NULL)
-#endif /* __rtems__ */
 		return (EBADF);
 	*kqp = kq;
 	KQ_LOCK(kq);
@@ -2117,7 +2090,6 @@ done_nl:
 	return (error);
 }
 
-#ifndef __rtems__
 /*ARGSUSED*/
 static int
 kqueue_ioctl(struct file *fp, u_long cmd, void *data,
@@ -2165,7 +2137,6 @@ kqueue_ioctl(struct file *fp, u_long cmd, void *data,
 
 	return (ENOTTY);
 }
-#endif /* __rtems__ */
 
 /*ARGSUSED*/
 static int
@@ -2193,39 +2164,14 @@ kqueue_poll(struct file *fp, int events, struct ucred *active_cred,
 	KQ_UNLOCK(kq);
 	return (revents);
 }
-#ifdef __rtems__
-static int
-rtems_bsd_kqueue_poll(rtems_libio_t *iop, int events)
-{
-	struct thread *td = rtems_bsd_get_curthread_or_null();
-	struct file *fp = rtems_bsd_iop_to_fp(iop);
-	int error;
-
-	if (td != NULL) {
-		error = kqueue_poll(fp, events, NULL, td);
-	} else {
-		error = ENOMEM;
-	}
-
-	return error;
-}
-#endif /* __rtems__ */
 
 /*ARGSUSED*/
-#ifndef __rtems__
 static int
 kqueue_stat(struct file *fp, struct stat *st, struct ucred *active_cred,
 	struct thread *td)
 {
 
 	bzero((void *)st, sizeof *st);
-#else /* __rtems__ */
-static int
-rtems_bsd_kqueue_stat(const rtems_filesystem_location_info_t *loc,
-    struct stat *st)
-{
-	(void) loc;
-#endif /* __rtems__ */
 	/*
 	 * We no longer return kq_count because the unlocked value is useless.
 	 * If you spent all this time getting the count, why not spend your
@@ -2304,10 +2250,8 @@ static void
 kqueue_destroy(struct kqueue *kq)
 {
 
-#ifndef __rtems__
 	KASSERT(kq->kq_fdp == NULL,
 	    ("kqueue still attached to a file descriptor"));
-#endif /* __rtems__ */
 	seldrain(&kq->kq_sel);
 	knlist_destroy(&kq->kq_sel.si_note);
 	mtx_destroy(&kq->kq_lock);
@@ -2333,7 +2277,6 @@ kqueue_close(struct file *fp, struct thread *td)
 		return error;
 	kqueue_drain(kq, td);
 
-#ifndef __rtems__
 	/*
 	 * We could be called due to the knote_drop() doing fdrop(),
 	 * called from kqueue_register().  In this case the global
@@ -2350,12 +2293,6 @@ kqueue_close(struct file *fp, struct thread *td)
 	TAILQ_REMOVE(&fdp->fd_kqlist, kq, kq_list);
 	if (filedesc_unlock)
 		FILEDESC_XUNLOCK(fdp);
-#else /* __rtems__ */
-	(void)filedesc_unlock;
-	rtems_libio_lock();
-	TAILQ_REMOVE(&fd_kqlist, kq, kq_list);
-	rtems_libio_unlock();
-#endif /* __rtems__ */
 
 	kqueue_destroy(kq);
 	chgkqcnt(kq->kq_cred->cr_ruidinfo, -1, 0);
@@ -2365,25 +2302,7 @@ kqueue_close(struct file *fp, struct thread *td)
 
 	return (0);
 }
-#ifdef __rtems__
-static int
-rtems_bsd_kqueue_close(rtems_libio_t *iop)
-{
-	struct thread *td = rtems_bsd_get_curthread_or_null();
-	struct file *fp = rtems_bsd_iop_to_fp(iop);
-	int error;
-
-	if (td != NULL) {
-		error = kqueue_close(fp, td);
-	} else {
-		error = ENOMEM;
-	}
 
-	return rtems_bsd_error_to_status_and_errno(error);
-}
-#endif /* __rtems__ */
-
-#ifndef __rtems__
 static int
 kqueue_fill_kinfo(struct file *fp, struct kinfo_file *kif, struct filedesc *fdp)
 {
@@ -2391,7 +2310,6 @@ kqueue_fill_kinfo(struct file *fp, struct kinfo_file *kif, struct filedesc *fdp)
 	kif->kf_type = KF_TYPE_KQUEUE;
 	return (0);
 }
-#endif /* __rtems__ */
 
 static void
 kqueue_wakeup(struct kqueue *kq)
@@ -2756,28 +2674,18 @@ again:		/* need to reacquire lock since we have dropped it */
 void
 knote_fdclose(struct thread *td, int fd)
 {
-#ifndef __rtems__
 	struct filedesc *fdp = td->td_proc->p_fd;
-#endif /* __rtems__ */
 	struct kqueue *kq;
 	struct knote *kn;
 	int influx;
 
-#ifndef __rtems__
 	FILEDESC_XLOCK_ASSERT(fdp);
-#endif /* __rtems__ */
 
 	/*
 	 * We shouldn't have to worry about new kevents appearing on fd
 	 * since filedesc is locked.
 	 */
-#ifndef __rtems__
 	TAILQ_FOREACH(kq, &fdp->fd_kqlist, kq_list) {
-#else /* __rtems__ */
-	/* FIXME: Use separate lock? */
-	rtems_libio_lock();
-	TAILQ_FOREACH(kq, &fd_kqlist, kq_list) {
-#endif /* __rtems__ */
 		KQ_LOCK(kq);
 
 again:
@@ -2800,9 +2708,6 @@ again:
 		}
 		KQ_UNLOCK_FLUX(kq);
 	}
-#ifdef __rtems__
-	rtems_libio_unlock();
-#endif /* __rtems__ */
 }
 
 static int
@@ -2865,7 +2770,14 @@ knote_drop_detached(struct knote *kn, struct thread *td)
 	KQ_UNLOCK_FLUX(kq);
 
 	if (kn->kn_fop->f_isfd) {
+#ifndef __rtems__
 		fdrop(kn->kn_fp, td);
+#else /* __rtems__ */
+		if ((kn->kn_status & KN_FP_IS_IOP) == 0)
+		fdrop(kn->kn_fp, td);
+		else
+			rtems_libio_iop_drop((rtems_libio_t*) kn->kn_fp);
+#endif /* __rtems__ */
 		kn->kn_fp = NULL;
 	}
 	kqueue_fo_release(kn->kn_kevent.filter);
@@ -2947,23 +2859,3 @@ noacquire:
 	fdrop(fp, td);
 	return (error);
 }
-#ifdef __rtems__
-static const rtems_filesystem_file_handlers_r kqueueops = {
-	.open_h = rtems_filesystem_default_open,
-	.close_h = rtems_bsd_kqueue_close,
-	.read_h = rtems_filesystem_default_read,
-	.write_h = rtems_filesystem_default_write,
-	.ioctl_h = rtems_filesystem_default_ioctl,
-	.lseek_h = rtems_filesystem_default_lseek,
-	.fstat_h = rtems_bsd_kqueue_stat,
-	.ftruncate_h = rtems_filesystem_default_ftruncate,
-	.fsync_h = rtems_filesystem_default_fsync_or_fdatasync,
-	.fdatasync_h = rtems_filesystem_default_fsync_or_fdatasync,
-	.fcntl_h = rtems_filesystem_default_fcntl,
-	.poll_h = rtems_bsd_kqueue_poll,
-	.kqfilter_h = rtems_bsd_kqueue_kqfilter,
-	.readv_h = rtems_filesystem_default_readv,
-	.writev_h = rtems_filesystem_default_writev,
-	.mmap_h = rtems_filesystem_default_mmap
-};
-#endif /* __rtems__ */
diff --git a/freebsd/sys/kern/kern_mib.c b/freebsd/sys/kern/kern_mib.c
index d7d8a356..0cdc8515 100644
--- a/freebsd/sys/kern/kern_mib.c
+++ b/freebsd/sys/kern/kern_mib.c
@@ -71,10 +71,8 @@ SYSCTL_ROOT_NODE(CTL_KERN,	  kern,   CTLFLAG_RW|CTLFLAG_CAPRD, 0,
 	"High kernel, proc, limits &c");
 SYSCTL_ROOT_NODE(CTL_VM,	  vm,     CTLFLAG_RW, 0,
 	"Virtual memory");
-#ifndef __rtems__
 SYSCTL_ROOT_NODE(CTL_VFS,	  vfs,     CTLFLAG_RW, 0,
 	"File system");
-#endif /* __rtems__ */
 SYSCTL_ROOT_NODE(CTL_NET,	  net,    CTLFLAG_RW, 0,
 	"Network, (see socket.h)");
 SYSCTL_ROOT_NODE(CTL_DEBUG,  debug,  CTLFLAG_RW, 0,
diff --git a/freebsd/sys/kern/kern_sysctl.c b/freebsd/sys/kern/kern_sysctl.c
index f529704a..71cbd2d8 100644
--- a/freebsd/sys/kern/kern_sysctl.c
+++ b/freebsd/sys/kern/kern_sysctl.c
@@ -1773,11 +1773,7 @@ sysctl_new_kernel(struct sysctl_req *req, void *p, size_t l)
 
 int
 kernel_sysctl(struct thread *td, int *name, u_int namelen, void *old,
-#ifndef __rtems__
     size_t *oldlenp, void *new, size_t newlen, size_t *retval, int flags)
-#else /* __rtems__ */
-    size_t *oldlenp, const void *new, size_t newlen, size_t *retval, int flags)
-#endif /* __rtems__ */
 {
 	int error = 0;
 	struct sysctl_req req;
diff --git a/freebsd/sys/kern/subr_pctrie.c b/freebsd/sys/kern/subr_pctrie.c
index c5f2c06e..0077aa7a 100644
--- a/freebsd/sys/kern/subr_pctrie.c
+++ b/freebsd/sys/kern/subr_pctrie.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-2-Clause-FreeBSD
  *
@@ -49,7 +51,7 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_ddb.h"
+#include <rtems/bsd/local/opt_ddb.h>
 
 #include <sys/param.h>
 #include <sys/systm.h>
diff --git a/freebsd/sys/kern/sys_generic.c b/freebsd/sys/kern/sys_generic.c
index 611e3166..827380ce 100644
--- a/freebsd/sys/kern/sys_generic.c
+++ b/freebsd/sys/kern/sys_generic.c
@@ -77,12 +77,6 @@ __FBSDID("$FreeBSD$");
 #endif
 
 #include <security/audit/audit.h>
-#ifdef __rtems__
-#include <machine/rtems-bsd-syscall-api.h>
-
-static int kern_select(struct thread *, int, fd_set *, fd_set *,
-    fd_set *, struct timeval *, int);
-#endif /* __rtems__ */
 
 /*
  * The following macro defines how many bytes will be allocated from
@@ -98,7 +92,6 @@ static int kern_select(struct thread *, int, fd_set *, fd_set *,
 #define	SYS_IOCTL_SMALL_SIZE	128	/* bytes */
 #define	SYS_IOCTL_SMALL_ALIGN	8	/* bytes */
 
-#ifndef __rtems__
 #ifdef __LP64__
 static int iosize_max_clamp = 0;
 SYSCTL_INT(_debug, OID_AUTO, iosize_max_clamp, CTLFLAG_RW,
@@ -108,6 +101,7 @@ SYSCTL_INT(_debug, OID_AUTO, devfs_iosize_max_clamp, CTLFLAG_RW,
     &devfs_iosize_max_clamp, 0, "Clamp max i/o size to INT_MAX for devices");
 #endif
 
+#ifndef __rtems__
 /*
  * Assert that the return value of read(2) and write(2) syscalls fits
  * into a register.  If not, an architecture will need to provide the
@@ -130,12 +124,10 @@ static int	selscan(struct thread *, fd_mask **, fd_mask **, int);
 static int	selrescan(struct thread *, fd_mask **, fd_mask **);
 static void	selfdalloc(struct thread *, void *);
 static void	selfdfree(struct seltd *, struct selfd *);
-#ifndef __rtems__
 static int	dofileread(struct thread *, int, struct file *, struct uio *,
 		    off_t, int);
 static int	dofilewrite(struct thread *, int, struct file *, struct uio *,
 		    off_t, int);
-#endif /* __rtems__ */
 static void	doselwakeup(struct selinfo *, int);
 static void	seltdinit(struct thread *);
 static int	seltdwait(struct thread *, sbintime_t, sbintime_t);
@@ -176,7 +168,6 @@ struct selfd {
 static uma_zone_t selfd_zone;
 static struct mtx_pool *mtxpool_select;
 
-#ifndef __rtems__
 #ifdef __LP64__
 size_t
 devfs_iosize_max(void)
@@ -221,6 +212,7 @@ sys_read(struct thread *td, struct read_args *uap)
 	return (error);
 }
 
+#ifndef __rtems__
 /*
  * Positioned read system call
  */
@@ -267,6 +259,7 @@ freebsd6_pread(struct thread *td, struct freebsd6_pread_args *uap)
 	return (kern_pread(td, uap->fd, uap->buf, uap->nbyte, uap->offset));
 }
 #endif
+#endif /* __rtems__ */
 
 /*
  * Scatter read system call.
@@ -306,6 +299,7 @@ kern_readv(struct thread *td, int fd, struct uio *auio)
 	return (error);
 }
 
+#ifndef __rtems__
 /*
  * Scatter positioned read system call.
  */
@@ -350,6 +344,7 @@ kern_preadv(struct thread *td, int fd, struct uio *auio, off_t offset)
 	fdrop(fp, td);
 	return (error);
 }
+#endif /* __rtems__ */
 
 /*
  * Common code for readv and preadv that reads data in
@@ -422,6 +417,7 @@ sys_write(struct thread *td, struct write_args *uap)
 	return (error);
 }
 
+#ifndef __rtems__
 /*
  * Positioned write system call.
  */
@@ -469,6 +465,7 @@ freebsd6_pwrite(struct thread *td, struct freebsd6_pwrite_args *uap)
 	return (kern_pwrite(td, uap->fd, uap->buf, uap->nbyte, uap->offset));
 }
 #endif
+#endif /* __rtems__ */
 
 /*
  * Gather write system call.
@@ -508,6 +505,7 @@ kern_writev(struct thread *td, int fd, struct uio *auio)
 	return (error);
 }
 
+#ifndef __rtems__
 /*
  * Gather positioned write system call.
  */
@@ -552,6 +550,7 @@ kern_pwritev(struct thread *td, int fd, struct uio *auio, off_t offset)
 	fdrop(fp, td);
 	return (error);
 }
+#endif /* __rtems__ */
 
 /*
  * Common code for writev and pwritev that writes data to
@@ -583,12 +582,14 @@ dofilewrite(struct thread *td, int fd, struct file *fp, struct uio *auio,
 		if (auio->uio_resid != cnt && (error == ERESTART ||
 		    error == EINTR || error == EWOULDBLOCK))
 			error = 0;
+#ifndef __rtems__
 		/* Socket layer is responsible for issuing SIGPIPE. */
 		if (fp->f_type != DTYPE_SOCKET && error == EPIPE) {
 			PROC_LOCK(td->td_proc);
 			tdsignal(td, SIGPIPE);
 			PROC_UNLOCK(td->td_proc);
 		}
+#endif /* __rtems__ */
 	}
 	cnt -= auio->uio_resid;
 #ifdef KTRACE
@@ -678,7 +679,11 @@ sys_ioctl(struct thread *td, struct ioctl_args *uap)
 	if (uap->com > 0xffffffff) {
 		printf(
 		    "WARNING pid %d (%s): ioctl sign-extension ioctl %lx\n",
+#ifndef __rtems__
 		    td->td_proc->p_pid, td->td_name, uap->com);
+#else /* __rtems__ */
+		    1, "BSD", uap->com);
+#endif /* __rtems__ */
 		uap->com &= 0xffffffff;
 	}
 	com = uap->com;
@@ -706,7 +711,11 @@ sys_ioctl(struct thread *td, struct ioctl_args *uap)
 			size = 0;
 		} else {
 			if (size > SYS_IOCTL_SMALL_SIZE)
+#ifndef __rtems__
 				data = malloc((u_long)size, M_IOCTLOPS, M_WAITOK);
+#else /* __rtems__ */
+				panic("libbsd: ioctl size too big");
+#endif /* __rtems__ */
 			else
 				data = smalldata;
 		}
@@ -730,8 +739,10 @@ sys_ioctl(struct thread *td, struct ioctl_args *uap)
 		error = copyout(data, uap->data, (u_int)size);
 
 out:
+#ifndef __rtems__
 	if (size > SYS_IOCTL_SMALL_SIZE)
 		free(data, M_IOCTLOPS);
+#endif /* __rtems__ */
 	return (error);
 }
 
@@ -835,7 +846,6 @@ out:
 		fdrop(fp, td);
 	return (error);
 }
-#endif /* __rtems__ */
 
 int
 poll_no_poll(int events)
@@ -853,7 +863,6 @@ poll_no_poll(int events)
 	return (events & (POLLIN | POLLOUT | POLLRDNORM | POLLWRNORM));
 }
 
-#ifndef __rtems__
 int
 sys_pselect(struct thread *td, struct pselect_args *uap)
 {
@@ -887,6 +896,7 @@ kern_pselect(struct thread *td, int nd, fd_set *in, fd_set *ou, fd_set *ex,
 {
 	int error;
 
+#ifndef __rtems__
 	if (uset != NULL) {
 		error = kern_sigprocmask(td, SIG_SETMASK, uset,
 		    &td->td_oldsigmask, 0);
@@ -902,6 +912,7 @@ kern_pselect(struct thread *td, int nd, fd_set *in, fd_set *ou, fd_set *ex,
 		td->td_flags |= TDF_ASTPENDING;
 		thread_unlock(td);
 	}
+#endif /* __rtems__ */
 	error = kern_select(td, nd, in, ou, ex, tvp, abi_nfdbits);
 	return (error);
 }
@@ -930,7 +941,6 @@ sys_select(struct thread *td, struct select_args *uap)
 	return (kern_select(td, uap->nd, uap->in, uap->ou, uap->ex, tvp,
 	    NFDBITS));
 }
-#endif /* __rtems__ */
 
 /*
  * In the unlikely case when user specified n greater then the last
@@ -1000,14 +1010,11 @@ kern_select(struct thread *td, int nd, fd_set *fd_in, fd_set *fd_ou,
 
 	if (nd < 0)
 		return (EINVAL);
-#ifndef __rtems__
 	fdp = td->td_proc->p_fd;
-#endif /* __rtems__ */
 	ndu = nd;
 #ifndef __rtems__
 	lf = fdp->fd_lastfile;
 #else /* __rtems__ */
-	(void) fdp;
 	lf = rtems_libio_number_iops;
 #endif /* __rtems__ */
 	if (nd > lf + 1)
@@ -1162,65 +1169,6 @@ done:
 
 	return (error);
 }
-#ifdef __rtems__
-int
-select(int nfds, fd_set *readfds, fd_set *writefds, fd_set *errorfds,
-    struct timeval *timeout)
-{
-	struct thread *td = rtems_bsd_get_curthread_or_null();
-	int error;
-
-	if (td != NULL) {
-		error = kern_select(td, nfds, readfds, writefds, errorfds,
-		    timeout, NFDBITS);
-	} else {
-		error = ENOMEM;
-	}
-
-	if (error == 0) {
-		return td->td_retval[0];
-	} else {
-		rtems_set_errno_and_return_minus_one(error);
-	}
-}
-
-int
-pselect(int nfds, fd_set *readfds, fd_set *writefds, fd_set *errorfds,
-    const struct timespec *timeout, const sigset_t *set)
-{
-	struct thread *td;
-	int error;
-
-	if (set != NULL) {
-		rtems_set_errno_and_return_minus_one(ENOSYS);
-	}
-
-	td = rtems_bsd_get_curthread_or_null();
-
-	if (td != NULL) {
-		struct timeval tv;
-		struct timeval *tvp;
-
-		if (timeout != NULL) {
-			TIMESPEC_TO_TIMEVAL(&tv, timeout);
-			tvp = &tv;
-		} else {
-			tvp = NULL;
-		}
-
-		error = kern_select(td, nfds, readfds, writefds, errorfds,
-		    tvp, NFDBITS);
-	} else {
-		error = ENOMEM;
-	}
-
-	if (error == 0) {
-		return td->td_retval[0];
-	} else {
-		rtems_set_errno_and_return_minus_one(error);
-	}
-}
-#endif /* __rtems__ */
 
 /* 
  * Convert a select bit set to poll flags.
@@ -1291,6 +1239,17 @@ selsetbits(fd_mask **ibits, fd_mask **obits, int idx, fd_mask bit, int events)
 static __inline int
 getselfd_cap(struct filedesc *fdp, int fd, struct file **fpp)
 {
+#ifdef __rtems__
+	rtems_libio_t *iop;
+	int ffd = rtems_bsd_libio_iop_hold(fd, &iop);
+	if (ffd < 0)
+		return EBADF;
+	if (iop != NULL) {
+		*fpp = NULL;
+		return 0;
+	}
+	fd = ffd;
+#endif /* __rtems__ */
 
 	return (fget_unlocked(fdp, fd, &cap_event_rights, fpp, NULL));
 }
@@ -1312,11 +1271,7 @@ selrescan(struct thread *td, fd_mask **ibits, fd_mask **obits)
 	int fd, ev, n, idx;
 	int error;
 
-#ifndef __rtems__
 	fdp = td->td_proc->p_fd;
-#else /* __rtems__ */
-	fdp = NULL;
-#endif /* __rtems__ */
 	stp = td->td_sel;
 	n = 0;
 	STAILQ_FOREACH_SAFE(sfp, &stp->st_selq, sf_link, sfn) {
@@ -1331,8 +1286,15 @@ selrescan(struct thread *td, fd_mask **ibits, fd_mask **obits)
 			return (error);
 		idx = fd / NFDBITS;
 		bit = (fd_mask)1 << (fd % NFDBITS);
+#ifndef __rtems__
 		ev = fo_poll(fp, selflags(ibits, idx, bit), td->td_ucred, td);
 		fdrop(fp, td);
+#else /* __rtems__ */
+		ev = rtems_bsd_libio_fo_poll(fd, fp, selflags(ibits, idx, bit),
+					     td->td_ucred, td);
+		if (fp != NULL)
+			fdrop(fp, td);
+#endif /* __rtems__ */
 		if (ev != 0)
 			n += selsetbits(ibits, obits, idx, bit, ev);
 	}
@@ -1355,11 +1317,7 @@ selscan(struct thread *td, fd_mask **ibits, fd_mask **obits, int nfd)
 	int n, idx;
 	int error;
 
-#ifndef __rtems__
 	fdp = td->td_proc->p_fd;
-#else /* __rtems__ */
-	fdp = NULL;
-#endif /* __rtems__ */
 	n = 0;
 	for (idx = 0, fd = 0; fd < nfd; idx++) {
 		end = imin(fd + NFDBITS, nfd);
@@ -1372,8 +1330,16 @@ selscan(struct thread *td, fd_mask **ibits, fd_mask **obits, int nfd)
 			if (error)
 				return (error);
 			selfdalloc(td, (void *)(uintptr_t)fd);
+#ifndef __rtems__
 			ev = fo_poll(fp, flags, td->td_ucred, td);
 			fdrop(fp, td);
+#else /* __rtems__ */
+			ev = rtems_bsd_libio_fo_poll(fd, fp,
+						     selflags(ibits, idx, bit),
+						     td->td_ucred, td);
+			if (fp != NULL)
+				fdrop(fp, td);
+#endif /* __rtems__ */
 			if (ev != 0)
 				n += selsetbits(ibits, obits, idx, bit, ev);
 		}
@@ -1383,12 +1349,6 @@ selscan(struct thread *td, fd_mask **ibits, fd_mask **obits, int nfd)
 	return (0);
 }
 
-#ifdef __rtems__
-static int kern_poll(struct thread *td, struct pollfd *fds, u_int nfds,
-    struct timespec *tsp, sigset_t *uset);
-
-static
-#endif /* __rtems__ */
 int
 sys_poll(struct thread *td, struct poll_args *uap)
 {
@@ -1507,31 +1467,6 @@ out:
 		free(bits, M_TEMP);
 	return (error);
 }
-#ifdef __rtems__
-int
-poll(struct pollfd fds[], nfds_t nfds, int timeout)
-{
-	struct thread *td = rtems_bsd_get_curthread_or_null();
-	struct poll_args ua = {
-		.fds = &fds[0],
-		.nfds = nfds,
-		.timeout = timeout
-	};
-	int error;
-
-	if (td != NULL) {
-		error = sys_poll(td, &ua);
-	} else {
-		error = ENOMEM;
-	}
-
-	if (error == 0) {
-		return td->td_retval[0];
-	} else {
-		rtems_set_errno_and_return_minus_one(error);
-	}
-}
-#endif /* __rtems__ */
 
 #ifndef __rtems__
 int
@@ -1577,11 +1512,7 @@ pollrescan(struct thread *td)
 	int n;
 
 	n = 0;
-#ifndef __rtems__
 	fdp = td->td_proc->p_fd;
-#else /* __rtems__ */
-	fdp = NULL;
-#endif /* __rtems__ */
 	stp = td->td_sel;
 	FILEDESC_SLOCK(fdp);
 	STAILQ_FOREACH_SAFE(sfp, &stp->st_selq, sf_link, sfn) {
@@ -1593,15 +1524,24 @@ pollrescan(struct thread *td)
 			continue;
 #ifndef __rtems__
 		fp = fdp->fd_ofiles[fd->fd].fde_file;
-#else /* __rtems__ */
-		fget_unlocked(fdp, fd->fd, NULL, &fp, NULL);
-#endif /* __rtems__ */
 #ifdef CAPABILITIES
 		if (fp == NULL ||
 		    cap_check(cap_rights(fdp, fd->fd), &cap_event_rights) != 0)
 #else
 		if (fp == NULL)
 #endif
+#else /* __rtems__ */
+		rtems_libio_t* iop;
+		int ffd = rtems_bsd_libio_iop_hold(fd->fd, &iop);
+		if (ffd >= 0) {
+			if (iop == NULL) {
+				fp = fdp->fd_ofiles[ffd].fde_file;
+			} else {
+				fp = NULL;
+			}
+		}
+		else
+#endif /* __rtems__ */
 		{
 			fd->revents = POLLNVAL;
 			n++;
@@ -1612,9 +1552,10 @@ pollrescan(struct thread *td)
 		 * Note: backend also returns POLLHUP and
 		 * POLLERR if appropriate.
 		 */
+#ifndef __rtems__
 		fd->revents = fo_poll(fp, fd->events, td->td_ucred, td);
-#ifdef __rtems__
-		rtems_libio_iop_drop(&fp->f_io);
+#else /* __rtems__ */
+		fd->revents = rtems_bsd_libio_fo_poll(ffd, fp, fd->events, td->td_ucred, td);
 #endif /* __rtems__ */
 		if (fd->revents != 0)
 			n++;
@@ -1650,11 +1591,7 @@ pollout(struct thread *td, struct pollfd *fds, struct pollfd *ufds, u_int nfd)
 static int
 pollscan(struct thread *td, struct pollfd *fds, u_int nfd)
 {
-#ifndef __rtems__
 	struct filedesc *fdp = td->td_proc->p_fd;
-#else /* __rtems__ */
-	struct filedesc *fdp = NULL;
-#endif /* __rtems__ */
 	struct file *fp;
 	int i, n = 0;
 
@@ -1663,7 +1600,7 @@ pollscan(struct thread *td, struct pollfd *fds, u_int nfd)
 #ifndef __rtems__
 		if (fds->fd > fdp->fd_lastfile) {
 #else /* __rtems__ */
-		if ((uint32_t)fds->fd >= rtems_libio_number_iops) {
+		if (fds->fd >= (int) rtems_libio_number_iops) {
 #endif /* __rtems__ */
 			fds->revents = POLLNVAL;
 			n++;
@@ -1672,15 +1609,24 @@ pollscan(struct thread *td, struct pollfd *fds, u_int nfd)
 		} else {
 #ifndef __rtems__
 			fp = fdp->fd_ofiles[fds->fd].fde_file;
-#else /* __rtems__ */
-			fget_unlocked(fdp, fds->fd, NULL, &fp, NULL);
-#endif /* __rtems__ */
 #ifdef CAPABILITIES
 			if (fp == NULL ||
 			    cap_check(cap_rights(fdp, fds->fd), &cap_event_rights) != 0)
 #else
 			if (fp == NULL)
 #endif
+#else /* __rtems__ */
+			rtems_libio_t* iop;
+			int ffd = rtems_bsd_libio_iop_hold(fds->fd, &iop);
+			if (ffd >= 0) {
+				if (iop == NULL) {
+					fp = fdp->fd_ofiles[ffd].fde_file;
+				} else {
+					fp = NULL;
+				}
+			}
+			if (ffd < 0)
+#endif /* __rtems__ */
 			{
 				fds->revents = POLLNVAL;
 				n++;
@@ -1690,10 +1636,12 @@ pollscan(struct thread *td, struct pollfd *fds, u_int nfd)
 				 * POLLERR if appropriate.
 				 */
 				selfdalloc(td, fds);
+#ifndef __rtems__
 				fds->revents = fo_poll(fp, fds->events,
 				    td->td_ucred, td);
-#ifdef __rtems__
-				rtems_libio_iop_drop(&fp->f_io);
+#else /* __rtems__ */
+				fds->revents = rtems_bsd_libio_fo_poll(ffd, fp, fds->events,
+				    td->td_ucred, td);
 #endif /* __rtems__ */
 				/*
 				 * POSIX requires POLLOUT to be never
@@ -2038,6 +1986,8 @@ kern_posix_error(struct thread *td, int error)
 #include <rtems/score/objectimpl.h>
 #include <rtems/score/threadimpl.h>
 
+#include <sys/socket.h>
+
 #include <rtems/bsd/util.h>
 
 static void
